<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::hash_map_kernel_1&lt; domain, range, expnum, hash_table, mem_manager &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1hash__map__kernel__1.html">hash_map_kernel_1</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1hash__map__kernel__1-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::hash_map_kernel_1&lt; domain, range, expnum, hash_table, mem_manager &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::hash_map_kernel_1&lt; domain, range, expnum, hash_table, mem_manager &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1hash__map__kernel__1.png" usemap="#dlib::hash_5Fmap_5Fkernel_5F1_3C_20domain_2C_20range_2C_20expnum_2C_20hash_5Ftable_2C_20mem_5Fmanager_20_3E_map" alt=""/>
  <map id="dlib::hash_5Fmap_5Fkernel_5F1_3C_20domain_2C_20range_2C_20expnum_2C_20hash_5Ftable_2C_20mem_5Fmanager_20_3E_map" name="dlib::hash_5Fmap_5Fkernel_5F1_3C_20domain_2C_20range_2C_20expnum_2C_20hash_5Ftable_2C_20mem_5Fmanager_20_3E_map">
<area href="classdlib_1_1enumerable.html" alt="dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;" shape="rect" coords="0,0,469,24"/>
<area href="classdlib_1_1pair__remover.html" alt="dlib::pair_remover&lt; domain, range &gt;" shape="rect" coords="479,0,948,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a44fdcde4fd1da1329adb797d30d1304f"><td class="memItemLeft" align="right" valign="top">typedef domain&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1hash__map__kernel__1.html#a44fdcde4fd1da1329adb797d30d1304f">domain_type</a></td></tr>
<tr class="separator:a44fdcde4fd1da1329adb797d30d1304f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a305464d4a8a3778585649adefa150361"><td class="memItemLeft" align="right" valign="top"><a id="a305464d4a8a3778585649adefa150361"></a>
typedef range&#160;</td><td class="memItemRight" valign="bottom"><b>range_type</b></td></tr>
<tr class="separator:a305464d4a8a3778585649adefa150361"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab27c472c2168c24b523151b30fc6a06c"><td class="memItemLeft" align="right" valign="top"><a id="ab27c472c2168c24b523151b30fc6a06c"></a>
typedef hash_table::compare_type&#160;</td><td class="memItemRight" valign="bottom"><b>compare_type</b></td></tr>
<tr class="separator:ab27c472c2168c24b523151b30fc6a06c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7aa315a10461bcfc43f5b76e4cb572af"><td class="memItemLeft" align="right" valign="top"><a id="a7aa315a10461bcfc43f5b76e4cb572af"></a>
typedef mem_manager&#160;</td><td class="memItemRight" valign="bottom"><b>mem_manager_type</b></td></tr>
<tr class="separator:a7aa315a10461bcfc43f5b76e4cb572af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a></td></tr>
<tr class="memitem:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#aece453aca3947d8b1f7bf016d5f99cda">type</a></td></tr>
<tr class="separator:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1pair__remover"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1pair__remover')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1pair__remover.html">dlib::pair_remover&lt; domain, range &gt;</a></td></tr>
<tr class="memitem:ae77d4c0fb6e38060543ef5323dfeeccc inherit pub_types_classdlib_1_1pair__remover"><td class="memItemLeft" align="right" valign="top">typedef domain&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1pair__remover.html#ae77d4c0fb6e38060543ef5323dfeeccc">domain_type</a></td></tr>
<tr class="separator:ae77d4c0fb6e38060543ef5323dfeeccc inherit pub_types_classdlib_1_1pair__remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7250053c066db818a5f0c0a886f25a20 inherit pub_types_classdlib_1_1pair__remover"><td class="memItemLeft" align="right" valign="top"><a id="a7250053c066db818a5f0c0a886f25a20"></a>
typedef range&#160;</td><td class="memItemRight" valign="bottom"><b>range_type</b></td></tr>
<tr class="separator:a7250053c066db818a5f0c0a886f25a20 inherit pub_types_classdlib_1_1pair__remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a100ede57d9c856bd291e5e46ec4b1efc"><td class="memItemLeft" align="right" valign="top"><a id="a100ede57d9c856bd291e5e46ec4b1efc"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a100ede57d9c856bd291e5e46ec4b1efc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a857931ae29297ed7320ce496fc574dc3"><td class="memItemLeft" align="right" valign="top"><a id="a857931ae29297ed7320ce496fc574dc3"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>add</b> (domain &amp;d, range &amp;r)</td></tr>
<tr class="separator:a857931ae29297ed7320ce496fc574dc3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a42c25a5e76db543316f5d4e006b2c79d"><td class="memItemLeft" align="right" valign="top"><a id="a42c25a5e76db543316f5d4e006b2c79d"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>is_in_domain</b> (const domain &amp;d) const</td></tr>
<tr class="separator:a42c25a5e76db543316f5d4e006b2c79d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba9c52763caf36381dc6d7aeab1cc7cd"><td class="memItemLeft" align="right" valign="top"><a id="aba9c52763caf36381dc6d7aeab1cc7cd"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>remove</b> (const domain &amp;d, domain &amp;d_copy, range &amp;r)</td></tr>
<tr class="separator:aba9c52763caf36381dc6d7aeab1cc7cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a839516eeb3f76b93df59735531e42e12"><td class="memItemLeft" align="right" valign="top"><a id="a839516eeb3f76b93df59735531e42e12"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>destroy</b> (const domain &amp;d)</td></tr>
<tr class="separator:a839516eeb3f76b93df59735531e42e12"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ace508d3b2a9b530efe2d8ed0a97dba17"><td class="memItemLeft" align="right" valign="top"><a id="ace508d3b2a9b530efe2d8ed0a97dba17"></a>
range &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (const domain &amp;d)</td></tr>
<tr class="separator:ace508d3b2a9b530efe2d8ed0a97dba17"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ae09d963d3127afa3a7dd8fa3bfc3a8"><td class="memItemLeft" align="right" valign="top"><a id="a3ae09d963d3127afa3a7dd8fa3bfc3a8"></a>
const range &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (const domain &amp;d) const</td></tr>
<tr class="separator:a3ae09d963d3127afa3a7dd8fa3bfc3a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3598579ddf65b18ef076dd996cb3a9ef"><td class="memItemLeft" align="right" valign="top"><a id="a3598579ddf65b18ef076dd996cb3a9ef"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>swap</b> (<a class="el" href="classdlib_1_1hash__map__kernel__1.html">hash_map_kernel_1</a> &amp;item)</td></tr>
<tr class="separator:a3598579ddf65b18ef076dd996cb3a9ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd3f074a7737c9bb060d0c54116673e8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1hash__map__kernel__1.html#afd3f074a7737c9bb060d0c54116673e8">remove_any</a> (domain &amp;d, range &amp;r)</td></tr>
<tr class="separator:afd3f074a7737c9bb060d0c54116673e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a29696c9c313362a244392c4ce80d948c"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1hash__map__kernel__1.html#a29696c9c313362a244392c4ce80d948c">size</a> () const</td></tr>
<tr class="separator:a29696c9c313362a244392c4ce80d948c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac18cf66d0b907a7eb1215ee6141c3c61"><td class="memItemLeft" align="right" valign="top"><a id="ac18cf66d0b907a7eb1215ee6141c3c61"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start</b> () const</td></tr>
<tr class="separator:ac18cf66d0b907a7eb1215ee6141c3c61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae2bb3dfc55ed025dbe82c0b702734f8a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1hash__map__kernel__1.html#ae2bb3dfc55ed025dbe82c0b702734f8a">reset</a> () const</td></tr>
<tr class="separator:ae2bb3dfc55ed025dbe82c0b702734f8a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa50156f0b04f572ca994bacc305700b4"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1hash__map__kernel__1.html#aa50156f0b04f572ca994bacc305700b4">current_element_valid</a> () const</td></tr>
<tr class="separator:aa50156f0b04f572ca994bacc305700b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a07e4bdf5ffde70b2dc1030811eb14584"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1hash__map__kernel__1.html#a07e4bdf5ffde70b2dc1030811eb14584">element</a> () const</td></tr>
<tr class="separator:a07e4bdf5ffde70b2dc1030811eb14584"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f69657e1be5b629e55e522a2989531c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1hash__map__kernel__1.html#a3f69657e1be5b629e55e522a2989531c">element</a> ()</td></tr>
<tr class="separator:a3f69657e1be5b629e55e522a2989531c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad8954299755e7aa07a9aaa812358842e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1hash__map__kernel__1.html#ad8954299755e7aa07a9aaa812358842e">move_next</a> () const</td></tr>
<tr class="separator:ad8954299755e7aa07a9aaa812358842e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a5667c3ec27a6cc56db19e6690b0df9f6"><td class="memItemLeft" align="right" valign="top"><a id="a5667c3ec27a6cc56db19e6690b0df9f6"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>hash_map_kernel_1</b> (<a class="el" href="classdlib_1_1hash__map__kernel__1.html">hash_map_kernel_1</a> &amp;)</td></tr>
<tr class="separator:a5667c3ec27a6cc56db19e6690b0df9f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac5f94a8e4491850a83c8b99a3c6c0782"><td class="memItemLeft" align="right" valign="top"><a id="ac5f94a8e4491850a83c8b99a3c6c0782"></a>
<a class="el" href="classdlib_1_1hash__map__kernel__1.html">hash_map_kernel_1</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1hash__map__kernel__1.html">hash_map_kernel_1</a> &amp;)</td></tr>
<tr class="separator:ac5f94a8e4491850a83c8b99a3c6c0782"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a67ab4bcd210b19778f7f196c79e5cd7b"><td class="memItemLeft" align="right" valign="top"><a id="a67ab4bcd210b19778f7f196c79e5cd7b"></a>
<a class="el" href="classdlib_1_1hash__table.html">hash_table</a>&#160;</td><td class="memItemRight" valign="bottom"><b>table</b></td></tr>
<tr class="separator:a67ab4bcd210b19778f7f196c79e5cd7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a></td></tr>
<tr class="memitem:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#a328c55c7c5df14e115cd502e9756e8a3">operator=</a> (const <a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;)</td></tr>
<tr class="separator:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1pair__remover"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1pair__remover')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1pair__remover.html">dlib::pair_remover&lt; domain, range &gt;</a></td></tr>
<tr class="memitem:aead61aff1af3e012c691953da8020750 inherit pro_methods_classdlib_1_1pair__remover"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1pair__remover.html">pair_remover</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1pair__remover.html#aead61aff1af3e012c691953da8020750">operator=</a> (const <a class="el" href="classdlib_1_1pair__remover.html">pair_remover</a> &amp;)</td></tr>
<tr class="separator:aead61aff1af3e012c691953da8020750 inherit pro_methods_classdlib_1_1pair__remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a44fdcde4fd1da1329adb797d30d1304f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a44fdcde4fd1da1329adb797d30d1304f">&#9670;&nbsp;</a></span>domain_type</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain, typename range, unsigned long expnum, typename hash_table, typename mem_manager = default_memory_manager&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef domain <a class="el" href="classdlib_1_1hash__map__kernel__1.html">dlib::hash_map_kernel_1</a>&lt; domain, range, expnum, <a class="el" href="classdlib_1_1hash__table.html">hash_table</a>, mem_manager &gt;::<a class="el" href="classdlib_1_1hash__map__kernel__1.html#a44fdcde4fd1da1329adb797d30d1304f">domain_type</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">REQUIREMENTS ON hash_table
    hash_table is instantiated with domain and range and
    T_is_POD must be set to false and
    implements hash_table/hash_table_kernel_abstract.h

INITIAL VALUE
    table.size() == 0

CONVENTION
    table.size() = size() == the number of elements in the map 
    the elements in this hash_map are stored in table
</pre><p> ! </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aa50156f0b04f572ca994bacc305700b4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa50156f0b04f572ca994bacc305700b4">&#9670;&nbsp;</a></span>current_element_valid()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , unsigned long expnum, typename hash_table , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1hash__map__kernel__1.html">dlib::hash_map_kernel_1</a>&lt; domain, range, expnum, <a class="el" href="classdlib_1_1hash__table.html">hash_table</a>, mem_manager &gt;::current_element_valid </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - #current_element_valid() == false 
    - #at_start() == true
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1d8826bb2077f454da01103773f892c6">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a3f69657e1be5b629e55e522a2989531c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3f69657e1be5b629e55e522a2989531c">&#9670;&nbsp;</a></span>element() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , unsigned long expnum, typename hash_table , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp; <a class="el" href="classdlib_1_1hash__map__kernel__1.html">dlib::hash_map_kernel_1</a>&lt; domain, range, expnum, <a class="el" href="classdlib_1_1hash__table.html">hash_table</a>, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a43a289e594edbf10a8300f5b49569524">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a07e4bdf5ffde70b2dc1030811eb14584"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a07e4bdf5ffde70b2dc1030811eb14584">&#9670;&nbsp;</a></span>element() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , unsigned long expnum, typename hash_table , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp; <a class="el" href="classdlib_1_1hash__map__kernel__1.html">dlib::hash_map_kernel_1</a>&lt; domain, range, expnum, <a class="el" href="classdlib_1_1hash__table.html">hash_table</a>, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if we are currently at a valid element else
      returns false 
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#ac8b8efc630a1ee6abe6ba2a153bf0047">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="ad8954299755e7aa07a9aaa812358842e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad8954299755e7aa07a9aaa812358842e">&#9670;&nbsp;</a></span>move_next()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , unsigned long expnum, typename hash_table , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1hash__map__kernel__1.html">dlib::hash_map_kernel_1</a>&lt; domain, range, expnum, <a class="el" href="classdlib_1_1hash__table.html">hash_table</a>, mem_manager &gt;::move_next </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a non-const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1b204b94acddc602ed8750731c7550ce">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="afd3f074a7737c9bb060d0c54116673e8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afd3f074a7737c9bb060d0c54116673e8">&#9670;&nbsp;</a></span>remove_any()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , unsigned long expnum, typename hash_table , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1hash__map__kernel__1.html">dlib::hash_map_kernel_1</a>&lt; domain, range, expnum, <a class="el" href="classdlib_1_1hash__table.html">hash_table</a>, mem_manager &gt;::remove_any </td>
          <td>(</td>
          <td class="paramtype">domain &amp;&#160;</td>
          <td class="paramname"><em>d</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">range &amp;&#160;</td>
          <td class="paramname"><em>r</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - all resources associated with *this have been released.
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1pair__remover.html#a07c56b5db740660bed160d3ed3e3770f">dlib::pair_remover&lt; domain, range &gt;</a>.</p>

</div>
</div>
<a id="ae2bb3dfc55ed025dbe82c0b702734f8a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae2bb3dfc55ed025dbe82c0b702734f8a">&#9670;&nbsp;</a></span>reset()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , unsigned long expnum, typename hash_table , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1hash__map__kernel__1.html">dlib::hash_map_kernel_1</a>&lt; domain, range, expnum, <a class="el" href="classdlib_1_1hash__table.html">hash_table</a>, mem_manager &gt;::reset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if *this represents one position before the first element
      in the container (this would also make the current element invalid) 
      else returns false                
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a2904ebf4bc18e60b5669509416827a3e">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a29696c9c313362a244392c4ce80d948c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a29696c9c313362a244392c4ce80d948c">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , unsigned long expnum, typename hash_table , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1hash__map__kernel__1.html">dlib::hash_map_kernel_1</a>&lt; domain, range, expnum, <a class="el" href="classdlib_1_1hash__table.html">hash_table</a>, mem_manager &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires                     
    - &amp;d != &amp;r (i.e. d and r cannot be the same variable) 
    - size() != 0
ensures
    - #size() == size() - 1
    - removes an element from the domain of *this and swaps it
      into d.  
    - removes the element in *this's range that is associated 
      with #d and swaps it into r.
    - if (*this implements the enumerable interface) then
        - #at_start() == true
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1pair__remover.html#a30eb487cc84f46066fbc446c46beb63b">dlib::pair_remover&lt; domain, range &gt;</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="hash__map__kernel__1_8h_source.html">hash_map_kernel_1.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
